var premiumproxyswitcher = {
	enabled: false,
	loading: false,
	proxies: new Array(),
	userProxies: new Array(),
	selectedProxy: null,
	rebuildProxyMenuList: true,
	serviceurl: 'http://freeproxylist.org/en/firefox-addon.php',
	serverporturl: 'http://freeproxylist.org/en/countryportlist.php?nojson=',
	countryflagsurl: 'http://freeproxylist.org/en/countryflags.php',
	prefManager: null,
	
	countryNames: new Array(),
	countryServers: new Array(),
	
	proxystatechecker: null,
	autodownloadinterval: null,
	autochangeinterval: null,
	loadingproxylist: false,
	propertiesBundle: null,
	updateUserCountryFlags: false,
	updateConfiguration: false,

  onLoad: function() {
	this.prefManager = Components.classes["@mozilla.org/preferences-service;1"]
								 .getService(Components.interfaces.nsIPrefBranch);
	
	var toolbar = document.getElementById('nav-bar');
	toolbar.insertItem('premiumproxyswitcher-toolbar-button');
	toolbar.setAttribute("currentset", toolbar.currentSet);
	document.persist(toolbar.id, "currentset");
	
	/*this.debug = document.createElementNS('http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul', 'label');
	toolbar.appendChild(this.debug);
	this.debug.setAttribute('value', 'debug');*/

    // initialization code
    this.initialized = true;
	
	var proxytype = this.prefManager.getIntPref("network.proxy.type");
	var initserver = this.prefManager.getCharPref("network.proxy.http");
	var initport = this.prefManager.getIntPref("network.proxy.http_port");
	
	if (initserver != null && initserver != '') {
		this.selectedProxy = {cc: '??', cn: "Unknown country", server: initserver, port: initport};
	}
	
	this.switchMode(proxytype > 0);
	this.onUpdateConfiguration(true);
	this.loadServerPortOptions();
	this.loadUserProxyList();
	this.loadCountryNamesServers();
	
	var instance = this;
	var event = { notify: function() {
		if (instance.loadingproxylist == true) {
			return;
		}
		if (instance.updateUserCountryFlags == true) {
			instance.updateUserCountryFlags = false;
			instance.updateCountryFlags(true);
		}
		if (instance.updateConfiguration == true) {
			instance.updateConfiguration = false;
			instance.onUpdateConfiguration();
		}
		
		var proxytype = instance.prefManager.getIntPref("network.proxy.type");
		var initserver = instance.prefManager.getCharPref("network.proxy.http");
		var initport = instance.prefManager.getIntPref("network.proxy.http_port");
		var cc = instance.prefManager.getCharPref("extensions.bestproxyswitcher.cc");
        var cn = instance.prefManager.getCharPref("extensions.bestproxyswitcher.cn");
		if (initserver != null && initserver != '') {
			instance.selectedProxy = {cc: cc, cn: cn, server: initserver, port: initport};
		}
		(proxytype == 0) ? instance.switchMode(false) : instance.switchMode(true);
		}}
	this.proxystatechecker = Components.classes["@mozilla.org/timer;1"]
									   .createInstance(Components.interfaces.nsITimer);
	this.proxystatechecker.initWithCallback(event, 300, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
  },
  
  onUpdateConfiguration: function(init) {
	init = (init == null) ? false : init;
	var instance = this;
  
	var auto = this.prefManager.getBoolPref('extensions.premiumproxyswitcher.optauto');
	if (this.autodownloadinterval != null) {
		this.autodownloadinterval.cancel();
		this.autodownloadinterval = null;
	}
	
	var timeout = this.prefManager.getIntPref('extensions.premiumproxyswitcher.optinterval');
	if (auto && timeout > 0) {
		var event = { notify: function() {instance.loadProxyServers();} }
		this.autodownloadinterval = Components.classes["@mozilla.org/timer;1"]
											  .createInstance(Components.interfaces.nsITimer);
		this.autodownloadinterval.initWithCallback(event, timeout*60*1000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
	}
	
	this.loadProxyServers(init);
	
	auto = this.prefManager.getBoolPref('extensions.premiumproxyswitcher.optautochange');
	if (this.autochangeinterval != null) {
		this.autochangeinterval.cancel();
		this.autochangeinterval = null;
	}
	
	timeout = this.prefManager.getIntPref('extensions.premiumproxyswitcher.optintervalchange');
	if (auto && timeout > 0) {
		var event = { notify: function() {instance.switchProxyServer();} }
		this.autochangeinterval = Components.classes["@mozilla.org/timer;1"]
											.createInstance(Components.interfaces.nsITimer);
		this.autochangeinterval.initWithCallback(event, timeout*60*1000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
	}
  },
  
  getPropertyString: function(name) {
	try{
		if (this.propertiesBundle == null) {
			var oBundle	= Components.classes['@mozilla.org/intl/stringbundle;1']
									.getService(Components.interfaces.nsIStringBundleService);
			this.propertiesBundle = oBundle.createBundle('chrome://premiumproxyswitcher/locale/premiumproxyswitcher.properties');
		}
		return this.propertiesBundle.GetStringFromName(name);
	}catch(err) {}
	
	return name;
  }
}

premiumproxyswitcher.loadServerPortOptions = function() {
	this.prefManager.setIntPref("network.proxy.type", 0);
	
	var request = new XMLHttpRequest();
	request.open("GET", this.serverporturl, true);
	request.responseType = 'text';
	
	var instance = this;
	request.onreadystatechange = function() {
		if ( request.readyState == 2 ) {
			instance.prefManager.setIntPref("network.proxy.type", originaltype);
			instance.updateStatusBar();
		}
		
		if ( request.readyState == 4 ) {
			if ( request.status == 200 ) {
				if(instance.prefManager.getPrefType('extensions.premiumproxyswitcher.showpreferences') !== 0) {
				    var showPreferences = instance.prefManager.getBoolPref('extensions.premiumproxyswitcher.showpreferences');
				    if (showPreferences) {
					    instance.openOptionDialog();
					    instance.prefManager.setBoolPref('extensions.premiumproxyswitcher.showpreferences', false);
				    }
				}
				var text = request.responseText;
				instance.prefManager.setCharPref('extensions.premiumproxyswitcher.serverportoptions', text);
			}
		}
	}
	
	request.send({});
}

premiumproxyswitcher.updateCountryFlags = function(userProxies) {
	if (userProxies == null) userProxies = false;
	proxiesToUpdate = (userProxies) ? this.userProxies : this.proxies;

	var proxyList = new Array();
	var doneProxies = new Array();
	for(var i in proxiesToUpdate) {
		var proxy = proxiesToUpdate[i];
		if (proxy.cc == '??') {
			if (typeof(this.countryServers[proxy.server]) == 'undefined') {
				proxyList.push(proxy.server+':'+proxy.port);
			} else {
				var cc = this.countryServers[proxy.server];
				var cn = this.countryNames[cc]
				doneProxies.push(cc+'|'+cn+'|'+proxy.server+':'+proxy.port);
			}
		} else {
			doneProxies.push(proxy.cc+'|'+proxy.cn+'|'+proxy.server+':'+proxy.port);
		}
	}
	if (proxyList.length == 0) {
		if (doneProxies.length > 0) {
			this.loadProxyList(doneProxies.join("\r\n"), userProxies);
		}
		return true;
	}

	var originaltype = this.prefManager.getIntPref("network.proxy.type");
	this.prefManager.setIntPref("network.proxy.type", 0);
	
	this.loading = true;
	this.updateStatusBar();

	var params = [];
	proxyListString = proxyList.join("\r\n")
	params.push('proxylist='+proxyListString);
	params = params.join('&');
	
	var request = new XMLHttpRequest();
	request.open("POST", this.countryflagsurl, true);
	request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
	request.setRequestHeader("Content-length", params.length);
	request.setRequestHeader("Connection", "close");
	
	var instance = this;
	request.onreadystatechange = function() {
		if ( request.readyState == 2 ) {
			instance.prefManager.setIntPref("network.proxy.type", originaltype);
			instance.updateStatusBar();
		}
		
		if ( request.readyState == 4 ) {
			instance.loading = false;
			instance.updateStatusBar();
			if ( request.status == 200 ) {
				var text = request.responseText;
				if (doneProxies.length > 0) {
					text += "\r\n"+doneProxies.join("\r\n");
				}
				instance.loadProxyList(text, userProxies);
			}
		}
	}
	
	request.send(params);
}

premiumproxyswitcher.loadUserProxyList = function() {
	var rawProxies = this.prefManager.getCharPref("extensions.premiumproxyswitcher.userproxylist").split('|');
	this.userProxies = new Array();
	if (rawProxies.length > 0)
		for(var i in rawProxies) {
			var rawData = rawProxies[i].split(';');
			if (rawData.length == 3) {
				var rawProxy = rawData[2].split(':');
				if (rawProxy.length == 2) {
					var proxy = {};
					proxy.cc = rawData[0];
					proxy.cn = rawData[1];
					proxy.server = rawProxy[0];
					proxy.port = rawProxy[1];
					this.userProxies.push(proxy);
				}
			}
		}	
}

premiumproxyswitcher.saveUserProxyList = function() {
	var pieces = new Array();
	for(var i in this.userProxies) {
		var proxy = this.userProxies[i];
		pieces.push(proxy.cc+';'+proxy.cn+';'+proxy.server+':'+proxy.port);
	}
	rawProxyList = pieces.join('|');
	
	this.prefManager.setCharPref("extensions.premiumproxyswitcher.userproxylist", rawProxyList);
}

premiumproxyswitcher.loadCountryNamesServers = function() {
	var rawCountryNames = this.prefManager.getCharPref("extensions.premiumproxyswitcher.countrynames").split('|');
	this.countryNames = new Array();
	if (rawCountryNames.length > 0)
		for(var i in rawCountryNames) {
			var rawData = rawCountryNames[i].split(';');
			if (rawData.length == 2) {
				this.countryNames[rawData[0]] = rawData[1];
			}
		}	

	var rawCountryServers = this.prefManager.getCharPref("extensions.premiumproxyswitcher.countryservers").split('|');
	this.countryServers = new Array();
	if (rawCountryServers.length > 0)
		for(var i in rawCountryServers) {
			var rawData = rawCountryServers[i].split(';');
			if (rawData.length == 2) {
				this.countryServers[rawData[0]] = rawData[1];
			}
		}	
}

premiumproxyswitcher.saveCountryNamesServers = function() {
	var pieces = new Array();
	for(var countryCode in this.countryNames) {
		var countryName = this.countryNames[countryCode];
		pieces.push(countryCode+';'+countryName);
	}
	this.prefManager.setCharPref("extensions.premiumproxyswitcher.countrynames", pieces.join('|'));

	var pieces = new Array();
	for(var countryServer in this.countryServers) {
		var countryCode = this.countryServers[countryServer];
		pieces.push(countryServer+';'+countryCode);
	}
	if (pieces.length > 5000) {
		pieces.splice(0, pieces.length-5000);
	}
	this.prefManager.setCharPref("extensions.premiumproxyswitcher.countryservers", pieces.join('|'));
}

premiumproxyswitcher.fetchProxyList = function(url, postfield) {
	//var ioService = Components.classes["@mozilla.org/network/io-service;1"]  
    //                      .getService(Components.interfaces.nsIIOService); 
	//var uri = ioService.newURI(myURLString, null, null);
	
	if (url == null) {
		this.loadProxyListFromCache();
		return;
	}
	
	if (url == null || url == '') {
		alert(this.getPropertyString('wrongUrl'));
		return;
	}
	
	
	this.loadingproxylist = true;
	this.loading = true;
	this.updateStatusBar();
	var request = new XMLHttpRequest();
	var params = {};
	
	var originaltype = this.prefManager.getIntPref("network.proxy.type");
	this.prefManager.setIntPref("network.proxy.type", 0);
	
	var updateCountryFlag = false;
	if (postfield != null) {
		params = [];
		for(var i in postfield) {
			params.push(i+'='+postfield[i]);
		}
		params = params.join('&');
		request.open("POST", url, true);
		request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		request.setRequestHeader("Content-length", params.length);
		request.setRequestHeader("Connection", "close");
	}else{
		request.open("GET", url, true);
		updateCountryFlag = true;
	}
	
	var instance = this;
	request.onreadystatechange = function() {
		if (request.readyState == 2) {
			instance.prefManager.setIntPref("network.proxy.type", originaltype);
			instance.updateStatusBar();
		}
		
		if (request.readyState == 4) {
			instance.loading = false;
			instance.updateStatusBar();
			instance.loadingproxylist = false;
			if (request.status == 200) {
				var text = request.responseText;
				if (text.indexOf('ERROR:') == 0) {
					alert(text);
					return;
				}
				
				instance.loadProxyList(text);
				if (updateCountryFlag)
					instance.updateCountryFlags();
				if (instance.selectedProxy == null)
					instance.switchProxyServer(null, false);
			}else{
				alert(instance.getPropertyString('proxyLoadFaild'));
			}
		}
	}
	
	request.send(params);
}

premiumproxyswitcher.toggleProxy = function(event) {
	var proxytype = this.prefManager.getIntPref("network.proxy.type");
	if (proxytype == 0) {
		if (this.proxies.length > 0 || this.userProxies.length > 0) {
			this.switchMode(true);
			this.prefManager.setIntPref("network.proxy.type", 1);
			this.switchProxyServer(null, false);
		}
	}else{
		this.switchMode(false);
		this.prefManager.setIntPref("network.proxy.type", 0);
	}
}

premiumproxyswitcher.loadProxyList = function(text, userProxies) {
	if (userProxies == null) userProxies = false;
	var lines = text.split('\n');
	
	var matches = text.match(/\w{2}\|[^\|]+\|(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}):(\d{1,5})/g);
	var proxyList = new Array();
	if (matches != null) {
		for(var i in matches) {
			var rawMatch = matches[i].split('|');
			var match = rawMatch[2];
			var pos = match.indexOf(':');
			if (pos > 0) {
				var proxy = {};
				proxy.server = match.substring(0, pos);
				proxy.port = parseInt(match.substring(pos+1));
				if (rawMatch[0] != 'NN' && rawMatch[1] != 'Unknown') {
					proxy.cc = rawMatch[0];
					proxy.cn = rawMatch[1];
					if (typeof(this.countryServers[proxy.server]) == 'undefined') {
						this.countryServers[proxy.server] = proxy.cc;
						if (typeof(this.countryNames[proxy.cc]) == 'undefined') {
							this.countryNames[proxy.cc] = proxy.cn;
						}
					}
				} else {
					proxy.cc = '??';
					proxy.cn = 'Uknown country';
				}
				proxyList.push(proxy);
			}
		}
	} else {
		var matches = text.match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}[^\d]+\d{1,5}/g);
		for(var i in matches) {
			var server = matches[i].match(/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/);
			var port = matches[i].match(/\d{1,5}$/);
			if (server !== null && port !== null) {
				var proxy = {};
				proxy.cc = '??';
				proxy.cn = 'Unknown country';
				proxy.server = server;
				proxy.port = port;
				proxyList.push(proxy);
			}
		}
	}
	
	if (userProxies) {
		this.userProxies = proxyList;
	} else {
		this.proxies = proxyList;
	}
	
	if (this.proxies.length == 0 && this.userProxies.length == 0) {
		alert(this.getPropertyString('noProxyFound'));
	} else {
		this.saveProxyListToCache();	
		this.saveUserProxyList();
		this.saveCountryNamesServers();
	}
	
	this.rebuildProxyMenuList = true;
}

premiumproxyswitcher.saveProxyListToCache = function() {
	var pieces = new Array();
	for(var i in this.proxies) {
		var proxy = this.proxies[i];
		pieces.push(proxy.cc+';'+proxy.cn+';'+proxy.server+':'+proxy.port);
	}
	rawProxyList = pieces.join('|');
	
	this.prefManager.setCharPref("extensions.premiumproxyswitcher.proxylist", rawProxyList);
}

premiumproxyswitcher.loadProxyListFromCache = function() {
	if(this.prefManager.getPrefType("extensions.premiumproxyswitcher.proxylist") === 0) {
		return;
	}
	
	var rawProxyList = this.prefManager.getCharPref("extensions.premiumproxyswitcher.proxylist").split('|');
	if (rawProxyList.length > 0)
		for(var i in rawProxyList) {
			var rawData = rawProxyList[i].split(';');
			if (rawData.length == 3) {
				var rawProxy = rawData[2].split(':');
				if (rawProxy.length == 2) {
					var proxy = {};
					proxy.cc = rawData[0];
					proxy.cn = rawData[1];
					proxy.server = rawProxy[0];
					proxy.port = rawProxy[1];
					this.proxies.push(proxy);
				}
			}
		}
	this.rebuildProxyMenuList = true;
}

premiumproxyswitcher.switchMode = function(enable) {
	this.enabled = enable;
	this.updateStatusBar();
}

premiumproxyswitcher.updateStatusBar=function() {
    var tB = this.$('premiumproxyswitcher-toolbar-button');
	if (this.loading) {
		tB.image = "chrome://premiumproxyswitcher/skin/loading_16.gif";
		tB.label = '';
	}else{
		if (this.enabled) {
		    try {
				if(this.selectedProxy.cc == "??" || this.selectedProxy.cc == ""){
					tB.image = "chrome://premiumproxyswitcher/skin/flags/unknown.png";
					tB.label = "";
				} else{
					tB.image = "chrome://premiumproxyswitcher/skin/flags/" + this.selectedProxy.cc + ".png";
					tB.label = "";
				}
			}
			catch (e) {
			}
		} else{
			tB.image = "chrome://premiumproxyswitcher/skin/disabled.png";
			tB.label = '';
		}
	}
	
	if (this.selectedProxy != null) {
	    var cc = '';
	    if(this.selectedProxy.cc != "??" && this.selectedProxy.cc != ""){
			cc = this.selectedProxy.cn + " (" + this.selectedProxy.cc + ") ";
		}
		tB.tooltipText = cc + this.selectedProxy.server+' : '+this.selectedProxy.port;
	} else {
		tB.tooltipText = this.getPropertyString('noProxySpesified');
	}
}

premiumproxyswitcher.$ = function (id) {
	return document.getElementById(id);
}

premiumproxyswitcher.switchProxyServer = function(proxy, autochange) {
	if (this.proxies.length == 0 && this.userProxies.length == 0) {
		this.prefManager.setIntPref("network.proxy.type", 0);
		this.setProxyServer();
		this.selectedProxy = null;
		this.switchMode(false);
		return;
	}
	 
	if (autochange == null) autochange = true;
	
	if (proxy == null) {
		if (this.proxies.length+this.userProxies.length == 1) {
			return;
		}

		var index = Math.floor(Math.random()*(this.proxies.length+this.userProxies.length)-this.userProxies.length);
		if (index > 0) {
			proxy = this.proxies[index];
		} else {
			proxy = this.userProxies[(-1*index)-1];
		}
	}
	
	if (autochange == true || this.selectedProxy == null) {
		this.selectedProxy = proxy;
	}
	
	this.rebuildProxyMenuList = true;
	this.setProxyServer(this.selectedProxy.server, this.selectedProxy.port, this.selectedProxy.cc, this.selectedProxy.cn);
	
	this.updateStatusBar();
}

premiumproxyswitcher.setProxyServer = function(server, port, cc, cn) {
	if (server == null) {
		server = '';
	}
	if (port == null) {
		port = 0;
	}	
	if (cc == null) {
	    cc = '??';
	}
	if (cn == null) {
	    cn = 'Unknown country';
	}
	
	this.prefManager.setCharPref("extensions.bestproxyswitcher.cc", cc);
    this.prefManager.setCharPref("extensions.bestproxyswitcher.cn", cn);
  
	this.prefManager.setCharPref("network.proxy.http",server);
	this.prefManager.setIntPref("network.proxy.http_port",port);
	this.prefManager.setCharPref("network.proxy.ssl",server);
	this.prefManager.setIntPref("network.proxy.ssl_port",port);
	this.prefManager.setCharPref("network.proxy.ftp",server);
	this.prefManager.setIntPref("network.proxy.ftp_port",port);
	this.prefManager.setCharPref("network.proxy.gopher",server);
	this.prefManager.setIntPref("network.proxy.gopher_port",port);
	this.prefManager.setCharPref("network.proxy.socks",server);
	this.prefManager.setIntPref("network.proxy.socks_port",port);		
}

premiumproxyswitcher.markSelectedDead = function() {
	if (this.selectedProxy == null) {
		return;
	}
	
	if (this.proxies.length > 0) {
		for(var i =0; i<this.proxies.length; i++) {
			if (this.isSameProxy(this.selectedProxy, this.proxies[i])) {
				this.proxies.splice(i, 1);
				this.saveProxyListToCache();
				this.rebuildProxyMenuList = true;
				break;
			}
		}
	}
	
	if (this.userProxies.length > 0) {
		for(var i =0; i<this.userProxies.length; i++) {
			if (this.isSameProxy(this.selectedProxy, this.userProxies[i])) {
				this.userProxies.splice(i, 1);
				this.saveUserProxyList();
				this.rebuildProxyMenuList = true;
				break;
			}
		}
	}
	
	this.switchProxyServer();
}

premiumproxyswitcher.loadProxyServers = function(fromCache) {
	fromCache = (fromCache == null) ? false : fromCache;

	if (fromCache) {
		this.fetchProxyList();
	} else {
		var useservice = this.prefManager.getBoolPref('extensions.premiumproxyswitcher.optuseservice');
		if (useservice) {
			var fields = {cc: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optcountry'),
					  ssl: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optssl'),
					  speed: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optminspeed'),
					  port: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optport'),
					  connect: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optconnect'),
					  ping: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optmaxping'),
					  type: this.prefManager.getCharPref('extensions.premiumproxyswitcher.opttype'),
					  post: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optpostget'),
					  uptime: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optminuptime'),
					  code: this.prefManager.getCharPref('extensions.premiumproxyswitcher.optvip'),
					  interval: this.prefManager.getIntPref('extensions.premiumproxyswitcher.optproxyinterval')};
		
			if (fields.port == 0) {
				fields.port == 'any';
			}
		
			if (fields.code.length == 16) {
				this.fetchProxyList(this.serviceurl, fields);
			} else {
				alert(this.getPropertyString('noVipPass'));
			}
		}else{
			var userurl = this.prefManager.getCharPref('extensions.premiumproxyswitcher.optcustomizeurl');
			this.fetchProxyList(userurl);
		}
	}
	
}

premiumproxyswitcher.openManageDialog = function() {
	window.openDialog("chrome://premiumproxyswitcher/content/manage.xul", "dialog=no", null);
}

premiumproxyswitcher.openOptionDialog = function() {
	window.openDialog("chrome://premiumproxyswitcher/content/options.xul", "dialog=no", null);
}

premiumproxyswitcher.openAboutDialog = function() {
	window.openDialog("chrome://premiumproxyswitcher/content/about.xul", "dialog=no", null);
}

premiumproxyswitcher.onPopupMenuShown = function() {
	var totalProxies = this.proxies.length+this.userProxies.length;
	this.$('pps-item-SelectProxyServer').setAttribute('disabled', (this.proxies.length == 0 && this.userProxies.length == 0));
	this.$('pps-item-SwitchProxyServer').setAttribute('disabled', ((this.proxies.length == 0 && this.userProxies.length == 0) || totalProxies == 1));
	this.$('pps-item-MarkSelectedDead').setAttribute('disabled', (this.selectedProxy == null));
	this.$('pps-item-EnableDisableProxyServer').label = this.getPropertyString((this.enabled) ? 'disableProxyServer' : 'enableProxyServer');
	this.$('pps-item-EnableDisableProxyServer').setAttribute('disabled', (this.selectedProxy == null));	
	
	if (this.rebuildProxyMenuList) {
		var menu = this.$('pps-item-SelectProxyServer-popup');
		for(var j=menu.childNodes.length-1;j>=0;j--) {
			menu.removeChild(menu.childNodes[j]);
		}
		
		for(i=0;i<this.userProxies.length;i++) {
			var proxy = this.userProxies[i];
			var isSelected = this.isSameProxy(this.selectedProxy, proxy);
			var index = (-1*i)-1;
			var oItem = this.createProxyItem(index, proxy, isSelected);
			menu.appendChild(oItem);
		}
		
		if (this.userProxies.length > 0 && this.proxies.length > 0) {
			var oSeparator = document.createElement('menuseparator');
			menu.appendChild(oSeparator);
		}
		
		for(i=0;i<this.proxies.length;i++) {
			var proxy = this.proxies[i];
			var isSelected = this.isSameProxy(this.selectedProxy, proxy);
			var oItem = this.createProxyItem(i, proxy, isSelected);
			menu.appendChild(oItem);
		}
		
		this.rebuildProxyMenuList = false;
	}

}

premiumproxyswitcher.createProxyItem = function(index, proxy, isSelected) {
	var oItem = document.createElement('menuitem');
	
	var oImage = document.createElement('image');
	var oLabel = document.createElement('label');

	oImage.setAttribute("src", "chrome://premiumproxyswitcher/skin/flags/"+((proxy.cc != '??') ? proxy.cc+".png" : "unknown.png"));
	oImage.setAttribute("class", "menu-iconic-icon");
	
	oLabel.setAttribute("value", proxy.server+':'+proxy.port);
	oLabel.setAttribute("class", "menu-iconic-text");
	oLabel.setAttribute("flex", "1");
	oLabel.setAttribute("crop", "right");
	if (isSelected) oLabel.setAttribute("style", "font-weight:bold");
	
//	oItem.innerHTML = proxy.server+':'+proxy.port;
	oItem.setAttribute("value", index);
	oItem.setAttribute("label", proxy.server+':'+proxy.port);
	oItem.setAttribute("tooltiptext", proxy.cn);
	oItem.setAttribute("valuehttp", proxy.server);
	oItem.setAttribute("valuehttpport", proxy.port);
	oItem.setAttribute("type", "radio");
	oItem.setAttribute("name", "proxieslist");
	oItem.setAttribute("class", "proxy-menu-item");
	oItem.appendChild(oImage);
	oItem.appendChild(oLabel);
			
	oItem.setAttribute("oncommand", "premiumproxyswitcher.selectProxy(this); event.preventBubble();");
	return oItem;
}

premiumproxyswitcher.selectProxy=function(comp) {
	var i = comp.getAttribute('value');
	// manual setup proxy
	this.prefManager.setIntPref("network.proxy.type", 1);
	this.switchMode(true);
	if (i < 0) {
		this.switchProxyServer(this.userProxies[(-1*i)-1]);
	} else {
		this.switchProxyServer(this.proxies[i]);
	}
}

premiumproxyswitcher.isSameProxy = function(one, another) {
	if (one != null && another != null && one.server == another.server && one.port == another.port) {
		return true;
	}else{
		return false;
	}
}

window.addEventListener("load", function(e) {  		
    premiumproxyswitcher.onLoad(e); 
}, false);